routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Auth::routes();

Route::get('/', "PagesController@homepage")->name('home');

Route::get('apply', "PagesController@apply")->name('apply')->middleware('auth');
Route::post('apply', "PagesController@postApply")->name('postApply')->middleware('auth');
Route::get('status', "PagesController@status")->name('status')->middleware('auth');

Route::resource('applications', 'App\\ApplicationsController')->middleware('admin');

app/Models/Application.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Application extends Model
{
    protected $guarded = [];

    // elenco dei campi che arrivano dalla form
    protected $fillable = ['user_id', 'first_name', 'last_name', 'email', 'phone', 'notes'];
}

app/Models/User.php
<?php

namespace App\Models;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/User.php
<?php

namespace App;

use Illuminate\Notifications\Notifiable;
use Illuminate\Foundation\Auth\User as Authenticatable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];
}

app/Http/Controllers/App/ApplicationsController.php
<?php

namespace App\Http\Controllers\App;

use App\Http\Controllers\Controller;
use App\Models\Application;
use Illuminate\Http\Request;
use Notification;
use App\Notifications\ApplicationUpdate;
use App\Models\User;

class ApplicationsController extends Controller
{

    public function __construct()
    {
        // Accessible only to admins
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index(Request $request)
    {
        if ($request->expectsJson())
            return Application::paginate(20);

        return view('applications.index');
    }

    public function accept(Request $request)
    {
        $data = $request->all();
        $application = Application::findOrFail($data['id']);
        $application->status = 2;
        $application->save();

        // send notification to user
        $user = User::where('id', $application->user_id)->get();
        Notification::send($user, new ApplicationUpdate($application));
    }

    public function refuse(Request $request)
    {
        $data = $request->all();
        $application = Application::findOrFail($data['id']);
        $application->status = 1;
        $application->save();

        // send notification to user
        $user = User::where('id', $application->user_id)->get();
        Notification::send($user, new ApplicationUpdate($application));
    }
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/HomeController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        return view('home');
    }
}

app/Http/Controllers/PagesController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\Application;
use Notification;
use App\Notifications\NewApplication;
use App\Notifications\SlackNotifiable;
use App\Models\User;
use Auth;

class PagesController extends Controller
{

    // 'first_name', 'last_name', 'email', 'phone', 'notes'

    protected $rules =
    [
        'first_name' => 'required|string|max:255',
        'last_name' => 'required|string|max:255',
        'email' => 'required|email|max:255|unique:applications',
        'phone' => 'required|regex:/^([0-9\s\-\+\(\)]*)$/|min:8|max:20',
        'notes' => 'nullable',
    ];

    protected $messages = [
        'first_name.required' => 'E\' necessario inserire il nome',
        'first_name.max' => 'Il nome non può essere più lungo di 255 caratteri',

        'last_name.required' => 'E\' necessario inserire il cognome',
        'last_name.max' => 'Il cognome non può essere più lungo di 255 caratteri',

        'email.required' => 'E\' necessario inserire un indirizzo mail',
        'email.max' => 'L\'indirizzo mail non può essere più lungo di 255 caratteri',
        'email.email' => 'L\'indirizzo mail deve essere valido',
        'email.unique' => 'Indirizzo mail già presente in archivo',

        'phone.required' => 'E\' necessario inserire un numero telefonico',
        'phone.max' => 'Il numero telefonico non può essere più lungo di 20 cifre',
        'phone.min' => 'Il numero telefonico non può essere più corto di 8 cifre',
        'phone.regex' => 'Caratteri non validi nel numero telefonico',
    ];

    public function homepage()
    {
        return view('home');
    }

    public function apply()
    {

        // verifica se esiste già un record per lo stesso utente    
        $user_id = Auth::user()->id;
        if (Application::where('user_id', $user_id)->exists()) {
            // se esiste rinvia alla pagina dello status
            return  redirect()->route('status');
        } else {
            return view('apply');
        }
    }

    public function postApply(Request $request)
    {

        $request->validate($this->rules, $this->messages);
        $data = $request->all();
        $data['user_id'] = $request->user()->id;

        $newApplication = new Application();
        $newApplication->fill($data);
        $newApplication->save();

        // send notification

        // via email to admins
        $admins = User::where('is_admin', true)->get();
        Notification::send($admins, new NewApplication($newApplication));

        // via slack
        // update .ENV with a key
        // SLACK_GENERAL_WEBHOOK_URL= _slack_webhook_url_
        (new SlackNotifiable())->notify(new NewApplication());

        return redirect()->route('home');
    }

    public function status()
    {
        $user_id = Auth::user()->id;
        $application = Application::where('user_id', $user_id)->first();

        return view('situation', compact('application'));
    }
}

resources/views/applications/complete.blade.php
@extends('layouts.main')

@section('content')
    <div id="contact">
        <div class="section-content">
            <h1 class="section-header">Grazie per la tua candidatura  <span class="content-header wow fadeIn " data-wow-delay="0.2s" data-wow-duration="2s"> {{$application->developer_first_name}}</span></h1>
            <h3>Riceverai presto una mail di risposta</h3>
        </div>

        <div class="contact-section">
            <div class="container">
                <a class="btn btn-default home-button submit" href="{{route('applications.create')}}">Torna alla home</a>
            </div>
        </div>
    </div>
@stop

resources/views/applications/index.blade.php
@extends('layouts.app')

@section('content')

<section class="container mt-4">
    <div class="row">

        <div class="col-12 ">

            <div class="card">
                <div class="card-header">
                    <div class="row">
                        <div class="col">
                            <h2>Applications</h2>
                        </div>
                    </div>
                </div>
                <div class="card-body">  
                    <applications inline-template>
                        <div>
                            <table class="w-100">
                                <thead>
                                    <th class="w-30">First name</th>
                                    <th class="w-30">Last name</th>
                                    <th class="text-center w-10">State</th>
                                    <th class="text-center">Actions</th>
                                </thead>

                                <tr v-for="(application, index) in items" :key="application.id">
                                    <td>@{{ application.first_name }}</td>
                                    <td>@{{ application.last_name }}</td>
                                    <td class="text-center">@{{ (application.status == 0) ? "-" : ((application.status == 2) ? "Accepted" : "Refused") }}</td>
                                    <td class="text-center">
                                        <a class="btn btn-success" :class="(application.status == 2) ? 'disabled':''" href="javascript:;" @click="accept(application.id)">{{__("Approve")}}</a> 
                                        <a class="btn btn-warning" :class="(application.status == 1) ? 'disabled':''"  href="javascript:;" @click="refuse(application.id)">{{__("Refuse")}}</a>
                                    </td>
                                </tr>
                            </table>

                            <paginator :dataSet="dataSet" @changed="fetch"></paginator>
                        </div>
                    </applications>
                </div>
            </div>

        </div>
    </div>
</section>

@endsection

resources/views/apply.blade.php
@extends('layouts.app')

@section('content')
    <section class="px-3 py-3 pt-md-5 pb-md-4 mx-auto text-center">
        <img src="https://www.bitboss.it/assets/bitboss_logo.svg"/>
        <div class="container">
            <h1>Candidati</h1>
            <p class="lead">Presenta la tua candidatura</p>
        </div>
    </section>
    <section>
        <div class="container">
            <div class="container">
                {!! Form::open(['route' => ['postApply'], 'method' => 'post'])!!}
                <div class="form-group">
                    {!! Form::label('first_name', 'Nome') !!}
                    {!! Form::text('first_name', null, ['class' => 'form-control ' .($errors->has('first_name') ? 'is-invalid': ''), 'placeholder'=>'Nome']) !!}
                    @if ($errors->has('first_name'))
                        <span class="text-danger">{{ $errors->first('first_name') }}</span>
                    @endif
                </div>

                <div class="form-group">
                    {!! Form::label('last_name', 'Cognome') !!}
                    {!! Form::text('last_name', null, ['class' => 'form-control ' .($errors->has('last_name') ? 'is-invalid': ''), 'placeholder'=>'Cognome']) !!}
                    @if ($errors->has('last_name'))
                        <span class="text-danger">{{ $errors->first('last_name') }}</span>
                    @endif                    
                </div>

                <div class="form-group">
                    {!! Form::label('email', 'Email') !!}
                    {!! Form::text('email', null, ['class' => 'form-control ' .($errors->has('email') ? 'is-invalid': ''), 'placeholder'=>'Email']) !!}
                    @if ($errors->has('email'))
                        <span class="text-danger">{{ $errors->first('email') }}</span>
                    @endif  
                </div>

                <div class="form-group">
                    {!! Form::label('phone', 'Telefono') !!}
                    {!! Form::text('phone', null, ['class' => 'form-control ' .($errors->has('phone') ? 'is-invalid': ''), 'placeholder'=>'Telefono']) !!}
                    @if ($errors->has('phone'))
                        <span class="text-danger">{{ $errors->first('phone') }}</span>
                    @endif 
                </div>

                <div class="form-group">
                    {!! Form::label('notes', 'Note') !!}
                    {!! Form::textarea('notes', null, ['rows'=>3, 'class' => 'form-control', 'placeholder'=>'Note']) !!}
                </div>

                <div>

                    <button type="submit" class="btn btn-lg btn-block btn-outline-primary"><i class="fa fa-paper-plane"
                                                                                              aria-hidden="true"></i>
                        {{__("Invia candidatura")}}
                    </button>
                </div>

                {!! Form::close() !!}
            </div>
    </section>

@stop

resources/views/home.blade.php
@extends('layouts.app')

@section('content')
    <section class="jumbotron text-center">
        <div class="container">
            <h1 class="jumbotron-heading">Welcome</h1>
            <p class="lead text-muted">Apply now to become a BitBoss developer</p>
            <p>
                <a href="{{route('apply')}}" class="btn btn-primary my-2">Apply</a>
            </p>
        </div>
    </section>
    <section class="">
        <div class="container">
            <h2>The Test</h2>

            <p>We built this test.</p>

            <p>We pretended to create this little - and ugly - application to collect applications from
                programmers. Can you finish it?</p>

            <p>Don't worry, we're not really going to use it to collect applications. We are better than that.</p>
            <h2>Requirements</h2>
            <ul>
                <li>Graphics
                </li>
                <ul>
                    <li class="done">Put the sticky footer at the bottom of the page
                    </li>
                </ul>
                <li>Features for users</li>
                <ul>
                    <li class="done">After registration, the user must be on the page to apply.</li>
                    <li class="done">The user's application must be stored
                    </li>
                    <li class="done">Associate the application with the user who sent it
                    </li>
                    <li class="done">Give the user the ability to access a page where the status is present
                        your application (accepted or rejected). At login the user is automatically taken
                        on this page.
                    </li>
                    <li class="done">A user cannot apply multiple times</li>
                </ul>
                <li>Features for Admin users</li>
                <ul>
                    <li class="done">Only admin users can access a section with a list of applications received
                    </li>
                    <li class="done">Notify when there is a new application (on Slack + Email to admin users)
                    </li>
                    <li class="done">Each candidate can be rejected or rejected. Create the logic of acceptance or rejection
                        after admin clicks the action button
                    </li>
                    <li class="done">Notify the candidate when they are accepted or rejected
                    </li>
                </ul>
                <li class="done">Populate the database with a seed of the applications
                </li>
            </ul>
            <h2>When you are done</h2>
            <p>Make a pull request on the repository. We will review the code you wrote.</p>
            <h2>What we will examine</h2>
            <p>We'll see if the code works and if the requirements are met, sure.</p>
            <p>But we'll also look at everything else: the quality and order of the code, the inventiveness to solve a
                problem, how much do you know about Laravel, the optimizations and the small details.</p>
            <p>Don't be afraid to use too much overengineering, to overturn everything, or, on the contrary, to use our
                trace, or being too mundane. Try - if you like
                - to
                surprise us.</p>
        </div>
    </section>
@endsection

resources/views/layouts/app.blade.php
<!DOCTYPE html>
<html lang="{{ app()->getLocale() }}">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">

    <!-- CSRF Token -->
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <title>{{ config('app.name', 'Laravel') }}</title>

    <!-- Scripts -->
    <script src="{{ asset('js/app.js') }}" defer></script>

    <!-- Fonts -->
    <link rel="dns-prefetch" href="https://fonts.gstatic.com">
    <link href="https://fonts.googleapis.com/css?family=Raleway:300,400,600" rel="stylesheet" type="text/css">

    <!-- Styles -->
    <link href="{{ asset('css/app.css') }}" rel="stylesheet">
</head>
<body>
    <div id="app">
        <nav class="navbar navbar-expand-md navbar-light navbar-laravel">
            <div class="container">
                <a class="navbar-brand" href="{{ url('/') }}">
                    {{ config('app.name', 'Laravel') }}
                </a>
                <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
                    <span class="navbar-toggler-icon"></span>
                </button>

                <div class="collapse navbar-collapse" id="navbarSupportedContent">
                    <!-- Left Side Of Navbar -->
                    <ul class="navbar-nav mr-auto">

                    </ul>

                    <!-- Right Side Of Navbar -->
                    <ul class="navbar-nav ml-auto">
                        <!-- Authentication Links -->
                        @guest
                            <li><a class="nav-link" href="{{ route('login') }}">{{ __('Login') }}</a></li>
                            <li><a class="nav-link" href="{{ route('register') }}">{{ __('Register') }}</a></li>
                        @else
                            <li class="nav-item dropdown">
                                <a id="navbarDropdown" class="nav-link dropdown-toggle" href="#" role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
                                    {{ Auth::user()->name }} <span class="caret"></span>
                                </a>

                                <div class="dropdown-menu" aria-labelledby="navbarDropdown">
                                    @if (Auth::user()->is_admin)
                                        <a class="dropdown-item" href="{{ route('applications.index') }}">
                                            {{ __('application.dashboard') }}
                                        </a>  
                                    @else
                                        <a class="dropdown-item" href="{{ route('status') }}">
                                            {{ __('application.status') }}
                                        </a>                                                               
                                    @endif     
                                    <hr class="dropdown-divider">
                                    <a class="dropdown-item" href="{{ route('logout') }}"
                                       onclick="event.preventDefault();
                                                     document.getElementById('logout-form').submit();">
                                        {{ __('Logout') }}
                                    </a>
                                    <form id="logout-form" action="{{ route('logout') }}" method="POST" style="display: none;">
                                        @csrf
                                    </form>
                                </div>
                            </li>
                        @endguest
                    </ul>
                </div>
            </div>
        </nav>

        <main class="bottom_margin">
            @yield('content')
        </main>
        <footer class="footer fixed-bottom">
            <div class="container">
                <span class="text-muted">Good Luck! © BitBoss srl</span>
            </div>
        </footer>

    </div>
</body>
</html>

resources/views/layouts/main.blade.php
<!DOCTYPE html>

<html lang="en">

<head>

    <meta charset="utf-8"/>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta content="width=device-width, initial-scale=1" name="viewport"/>
    <meta content=""
          name="description"/>
    <meta content="BitBossTest" name="author"/>
    <!-- BEGIN GLOBAL MANDATORY STYLES -->

    <title>{{ config('app.name', 'BitBossTest') }}</title>

    <meta name="csrf-token" content="{{ csrf_token() }}">


    <link href="https://fonts.googleapis.com/css?family=Poppins:400,300,600,700&subset=all" rel="stylesheet"
          type="text/css"/>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">

    <link href="{{asset("/css/app.css")}}" rel="stylesheet">

    <link rel="shortcut icon" href="favicon.ico"/>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>

<body>
    <div id="app">
        @yield('content')
    </div>


    <script src="{{ asset('js/app.js') }}"></script>
</body>

</html>

resources/views/situation.blade.php
@extends('layouts.app')

@section('content')
    <section class="px-3 py-3 pt-md-5 pb-md-4 mx-auto text-center">
        <div class="container">
            <h1>Candidatura</h1>
        </div>
    </section>

    <section class="jumbotron text-center">
        <div class="container">
            @if ($application)
                <h2>{{__("Your application is ") }} 
                @if ($application->status == 2)
                    <b>Accepted</b>
                @else
                    <b>Refused</b>
                @endif
                at {{date_format($application->updated_at,"d/m/Y H:i")}}
                </h2>
            @else
                <h2 >Apply now to become a BitBoss developer</h2>
                <p>
                    <a href="{{route('apply')}}" class="btn btn-primary my-2">Apply</a>
                </p>
            @endif
        </div>
    </section>
@stop